#!/usr/bin/perl

# Name: sound.cgi - Script von Gerold Bigorajski
# (Bigorajski@T-Online.de, http://www.gb-direkt.de)
#
# Version: 1.0
#
# Erstellt: 20.11.98
#
# Copyright-Info: Diese Anwendung wurde von Gerold Bigorajski
#	(info@gb-direkt.de, http://www.gb-direkt.de) geschrieben und zahllosen
#	anderen PERL-Autoren inspiriert. Sie darf frei kopiert und zitiert
#	werden, es drfen Code-Beispiele daraus entnommen, entlehnt, verkauft
#	oder plagiiert. werden. Gerold erbittet allerdings einen kurzen
#	Hinweis, was mit ihnen passiert, so da sie die Entwicklung der
#	Spielarten zumindest verfolgen kann.
#
# Dieses Script gibt in einer Datenbank aufgefuehrte midi-Dateien 
# einzeln oder nacheinander aus.
# Die Dateien werden in ein HTML-Template eingebunden, ueber das
# zusaetzliche Informationen an den Betrachter vermittelt werden
# koennen.
#
# Das Script kann auch als Sound-Zufallsgenerator verwendet werden, dass mit
# besagter HTML-Vorlage mit jedem neuen Laden einen neuen Sound aus der
# Datenbank herausgreift.
#
# Anmerkung: Die Beispieldatei im Unterverzeichnis HTML enthaelt mehrere
# wichtige Zeilen der Form: <!--DROPDOWN HIER --> ,  <!--NAME HIER--> , 
# die in jedem Fall in den Datei-Vorlagen fr die Sounds erscheinen mssen. 
# Nachdem die Setup-Variablen und die HTML-Datei serverspezifisch 
# konfiguriert sind, kann der Sound-Zufallsgenerator ausprobiert werden.

# $DEBUG - Wenn diese Variable auf 1 steht, lassen sich zusaetzliche Ausgaben 
# im Script definieren, um z.B. Variablenwerte anzuzeigen usw.

$DEBUG = 0;

#######################################################################
#                       http-Kopf ausgeben.                           #
#######################################################################

		# Als erstes wird der PERL-Interpreter angewisen, kontinuierlich seinen
		# Puffer zu leeren, so dass vom Script erzeugte Informationen direkt an
		# den Browser geschickt werden. Dies bewirkt die Zeile $! = 1; 
		#
		# Dann wird der http-Header ausgegeben, so dass ein Debug erleichtert
		# wird und der Browser nicht in ein Timeout laeuft.

$| = 1;
print "Content-type: text/html\n\n";

#######################################################################
#                       Bibliotheken laden.                           #
#######################################################################

		# Nun wird cgi-lib.pl geladen und die Routine ReadParse verwendet, um
		# jegliche hereinkommenden Formulardaten zu lesen und aufzubereiten.

$setup_file = "./Setup_files/sounds.setup";
require "$setup_file";

# Diese in der Setup-Datei angegebene Variable enthaelt den Speicherort fuer cgi-lib.pl
require "$location_of_cgi_lib";

# Einlesen der Formulardaten
&ReadParse(*form_data);

# Einige Variable
$script = "http://www.gb-direkt.de/cgi-bin/db_manager/sounds.cgi";
$aktion = $form_data{'aktion'};
$midi   = $form_data{'midis'};

#######################################################################
#      Definition der zu benutzenden Datenbank und HTML-Vorlage       #
#######################################################################

		# Die URL-kodierten Daten, die ggf. als Formulardaten herein-
		# kommen, sind der Name der Bilddatenbank, die das Script
		# benutzen soll, um den Speicherort der Bilder zu finden, sowie
		# die HTML-Vorlage.
		#
		# Wenn eine Bilddatenbank angegeben ist, wird der Variablen
		# $image_database dieser Wert zugewiesen. Wenn die Angabe fehlt,
		# benutzt das Script $default_image_list (in der Setup-Datei definiert).

if ($form_data{'sound_list'} ne "")
{
	$sound_database = $form_data{'sound_list'};
}
else
{
	$sound_database = "$default_sound_list";
}

		# Genauso muss das Script bestimmen, welche HTML-Datei es mit dem
		# Zufallsbild ausgeben soll. Standardmaessig wird die HTML-Datei
		# geladen, die in $default_html_file definiert ist. Wenn im Formular
		# allerdings eine alternative Vorlage angegeben ist, wird diese geladen.

if ($form_data{'html_file'} ne "")
{
	$html_file = "$html_directory_path/$form_data{'html_file'}";
}
else
{
	$html_file = "$default_html_file";
}


#######################################################################
#                       Hauptmenue.                                   #
#######################################################################

		# Das Script soll folgende Aktionen durchfuehren koennen:
		# (a)	Abspielen eines Zufallssounds (wechselt beim Neuladen).
		# (b)	Abspielen eines bestimmten Sounds aus der Gesamtauswahl.
		# (c)	Abspielen der gesamten Liste.

		# Mit dem Befehl srand wird der Zufallsgenerator initialisiert.

&read_sounds;

# Zufallsgenerator
if($aktion eq "random")
{
	srand (time|$$);
	$random_number = int(rand($sound_number));
	&play_sound($random_number, "");
	exit;
}

# Bestimmtes Stueck
elsif($aktion eq "spec")
{
	&play_sound($midi, "");
	exit;
}

# Alles nacheinander abspielen
elsif($aktion eq "all")
{
	if($midi + 1 >= $sound_number)
	{
		$increment = 0;
	}
	else
	{
		 $increment = $midi + 1;
	}
	&play_sound($increment, "$dauer_list[$increment]");
	exit;
}

# Jungfraeulicher Scriptaufruf
else
{
	&play_sound("", "");
	exit;
}


#######################################################################
#                     Subroutine read_sounds.                         #
#######################################################################

		# Als naechstes oeffnet das Script die Sounddatenbank oder
		# verabschiedet sich mittelds der Routine CgiDie, wenn es
		# beim Oeffnen der angegebenen bzw. definierten Sounddatenbank
		# ein Problem gibt.

sub read_sounds
{
	open (SOUND_DATABASE, "$sound_database") || 
		&CgiDie ("Leider konnte die Sound-Datenbank nicht geffnet werden.
		Der vorhandene Wert ist $sound_database. Bitte den Pfad und die
		Berechtigungen berpfen!");

	# Dann liest es zeilenweise durch die Sounddatenbank und splittet
	# jede Zeile in ihre Felder auf. Trennzeichen ist das PIPE-Symbol (|).
	# Die weiter verwerteten Informationen werden jeweils einem Array 
	# hinzugefuegt, so dass sie anschliessend zur Verfuegung stehen.
	#
	# Kommentarzeilen werden dabei ausgelassen.
	#
	# Am Ende wird die Sounddatenbank wieder geschlossen.

	while (<SOUND_DATABASE>)
	{
		unless (/^COMMENT:/)
		{
			($file, $name, $dauer, $index) = split (/\|/, $_);

			push (@file_list, $file);
			push (@name_list, $name);
			push (@dauer_list, $dauer);
			push (@index_list, $index);

		} # Ende der Abfrage unless (/^COMMENT:/)
	}
	close (SOUND_DATABASE);

	# Dies ermittelt die Anzahl der MIDI-Files in der Datenbank.
	$sound_number = @file_list;

} # Ende der Subroutine read_sounds


#######################################################################
#                     Subroutine play_sound                           #
#######################################################################

		# Nun hat das Script eine Liste aller Sounds in der Datenbank.
		#
		# Fuer die Ausgabe werden 2 Eingabeparameter erwartet:
		#	 1. Index:		Die eindeutige, interne ID-Nummer des Stcks.
		# 	 2. Dauer:		Die Abspieldauer des Stuecks (fuer Dauerabspielen ...)

sub play_sound
{
	local($sound, $dauer) = @_;

	# Einige Variable
	local($i)   = 0;
	local($sel) = "";
	local($full_url) = "$script\?aktion=$aktion\&midis=$sound";

	# HTML-Ausgabe
	print "<HTML>\n<HEAD>\n";

	# HTML-Refresh, falls die gesamte Liste abgespielt werden soll
	# (dafuer wird die Abspieldauer des Stuecks benoetigt)
	if ($dauer)
	{
		$dauer = $dauer + 10;
		print "<meta http-equiv=\"Refresh\" content=\"$dauer; URL=$full_url\">\n";
	}

	# Ein paar kleine Javascripte und dann die eigtentliche Ausgabe
	print qq~
<SCRIPT LANGUAGE="JavaScript">
<!--
window.resizeTo(330, 350);
window.moveTo(screen.width-470, 20);
	~;

	if($aktion)
	{
		print qq~
if(navigator.userAgent.indexOf("MSIE") != -1)
{
	document.writeln ('');
}
else
{
	document.writeln ('<EMBED SRC="$file_list[$sound]" AUTOSTART="true" HIDDEN="true" VOLUME="80%">');
}
		~;
	}

	# Die Spieldauern werden mit angezeigt
	print "\nvar Spieldauer = new Array(";
	for ($i = 0; $i < $sound_number; $i++)
	{
		print "$dauer_list[$i]";
		print "," if($i < $sound_number - 1);
	}
	print ")\;";

	print qq~
function zufallSpielen()
{
	var f = document.forms[0];
	f.aktion.value = "random";
	f.submit();
}


function einesSpielen()
{
	var f = document.forms[0];
	f.aktion.value = "spec";
	f.submit();
}


function alleSpielen()
{
	var f = document.forms[0];
	f.midis.options[0].selected = true;
	f.aktion.value = "all"
	f.submit();
}


function stoppen()
{
	var f = document.forms[0];
	f.aktion.value = "";
	f.submit();
}


function updateDauer()
{
	var f = document.forms[0];
	var i = f.midis.options.selectedIndex;
	var l = Spieldauer[i];
	var t = l / 60;
	var minute = Math.floor(t);
	var sekunde = Math.round((t - minute) * 60);
	if(sekunde < 10)
	{
		sekunde = "0" + sekunde;
	}
	var Ausgabe = minute + ":" + sekunde;
	f.dauer.value = Ausgabe;
	~;

	if($aktion)
	{
		print qq~
	var m = l * 1000 / 26;
	doit(0,m);
		~;
	}

	print qq~;
}


function doit(i,msec)
{
	var k = i;
	if(k <= 25)
	{
		eval("document.pict" + k + ".src = '$lilapict'");
		k++;
		window.setTimeout("doit(" + k + "," + msec + ")", msec);
	}
}



//-->
</SCRIPT>
</HEAD>
<body $bodytag onLoad="updateDauer()">
	~;

	if($aktion)
	{
		print "<BGSOUND SRC=\"$file_list[$sound]\">\n";
	}

	print qq~
<h3>$fonttag<font color="#003366">Whlen Sie Ihren Sound!</font></font></h3>

<FORM ACTION="$script" METHOD="POST">
	<INPUT TYPE="hidden" NAME="aktion" VALUE="$form_data{'aktion'}">
	<INPUT TYPE="hidden" NAME="Midi_File" VALUE="$name_list[$sound]">
	<INPUT TYPE="hidden" NAME="Index" VALUE="$sound">
	<INPUT TYPE="hidden" NAME="Datei" VALUE="$file_list[$sound]">

<SELECT NAME="midis" onChange="updateDauer()">
~;

	for ($i = 0; $i < $sound_number; $i++)
	{
		$sel = ($i == $sound) ? "SELECTED" : "";
		print "	<OPTION $sel VALUE=\"$i\">$name_list[$i]</OPTION>\n"
	}

	print qq~
</SELECT>
<INPUT TYPE="text" NAME="dauer" SIZE="5">
<p>
<table width="245" border="2">
	<tr>
		<td>
	~;

	for($i = 0; $i <=25; $i++)
	{
		# Dies ist fuer die Abspielanzeige zustaendig.
		# Achtung: Hier DARF kein '\n' und kein Leerzeichen am Ende stehen, 
		# sonst gibt es Abstaende zwischen den einzelnen Bildern!
		print "<image src=\"$blankpict\" name=\"pict$i\" height=\"12\" width=\"9\">";
	}

	print qq~
		</td>
	</tr>
</table>
<p>
<A HREF="javascript:zufallSpielen()"><IMG SRC="$randbutton" WIDTH="60" HEIGHT="34" BORDER="0" ALT="Zuflliges Stck spielen"></A> 
<A HREF="javascript:einesSpielen()"><IMG SRC="$playbutton" WIDTH="60" HEIGHT="34" BORDER="0" ALT="Ausgewhltes Stck spielen"></A> 
<A HREF="javascript:alleSpielen()"><IMG SRC="$allebutton" WIDTH="60" HEIGHT="34" BORDER="0" ALT="Alle Stck nacheinander spielen"></A> 
<A HREF="javascript:stoppen()"><IMG SRC="$stopbutton" WIDTH="60" HEIGHT="34" BORDER="0" ALT="Abspielen beenden"></A> 

</FORM>
</BODY>
</HTML>
	~;

} # Ende der Subroutine play_sound

